<template>
  <div class="bg-[#fff]">
    <a-page-header style="border: 1px solid rgb(235, 237, 240)" @back="router.go(-1)">
      <template #backIcon>
        <div><a-button type="primary">返回</a-button></div>
      </template>
      <template #title>
        <div></div>
      </template>
    </a-page-header>
    <a-collapse v-model:activeKey="activeKey" :bordered="false">
      <a-collapse-panel key="1" header="地块信息" :forceRender="true">
        <DkTable :data="dsInfor.wrdkjbxxb" />
      </a-collapse-panel>

      <a-collapse-panel key="2" header="管控及修复效果评估报告基本信息" :forceRender="true">
        <suBainForm
          ref="chilrenReport"
          labelFirst="效果评估"
          :obj="[{ name: '管控及修复效果评估报告' }, { name: '管控及修复效果评估报告编制' }]"
          :data="dsInfor.xgpg"
        />
        <template #extra><a-button type="primary" @click.prevent="saveReport($event)">保存</a-button></template>
      </a-collapse-panel>

      <a-collapse-panel
        header="管控及修复效果评估报告编制单位基本信息"
        :forceRender="true"
        v-for="(item, index) in unitMessageFormList"
        :key="index + 4"
      >
        <unitMessageForm :ref="(el) => childRef(el, index)" :data="item" />
        <template #extra>
          <a-button type="primary" @click.prevent="addUnitMessageFormList($event)">添加</a-button>
          <a-button type="primary" class="ml-5" v-if="index != 0" @click.prevent="delMessageFormList($event, index)">删除</a-button>
          <a-button type="primary" @click.prevent="suBainFormAddEdit($event, index)" style="margin-left: 10px">保存</a-button>
        </template>
      </a-collapse-panel>
      <a-collapse-panel
        header="管控及修复效果评估样品分析检测单位基本信息"
        :forceRender="true"
        v-for="(item, index) in detectionMessageFormList"
        :key="index + 7"
        :dkxx="{ wrdkid: dsInfor.wrdkjbxxb.wrdkid, scjdbm: 'S6' }"
      >
        <unitMessageForm :ref="(el) => childRefjc(el, index)" :upload="index + 1" :data="item" />
        <template #extra>
          <a-button type="primary" @click.prevent="addDetectionMessageFormList($event)">添加</a-button>
          <a-button type="primary" class="ml-5" v-if="index != 0" @click.prevent="deleJcdw($event, index)">删除</a-button>
          <a-button type="primary" @click.prevent="saveJcdw($event, index)" style="margin-left: 10px">保存</a-button>
        </template>
      </a-collapse-panel>
      <a-collapse-panel header="管控及修复措施信息" :forceRender="true" key="140000">
        <ControlInformation
          labelFirst="管控修复效果评估"
          ref="chilrenGkcs"
          :obj="[
            {
              name: '实际修复范围(m2)',
            },
            {
              name: '实际修复土壤方量(m3)',
            },
          ]"
          :data="dsInfor.xgpg"
        />
        <template #extra><a-button type="primary" @click.prevent="addGKcs($event)" style="margin-left: 10px">保存</a-button></template>
      </a-collapse-panel>
      <a-collapse-panel header="管控及修复效果评估文件上传" :forceRender="true" key="150000">
        <CdUpload ref="chilrenReportxx" labelFirst="效果评估" :objec="[{ name: '公示截图' }, { name: '评估报告' }]" :data="dsInfor.xgpg" />
      </a-collapse-panel>
      <a-collapse-panel header="填报进度" :forceRender="true" key="160000">
        <fillProgress :List="dsInfor?.lzjd"></fillProgress>
      </a-collapse-panel>
    </a-collapse>
  </div>
</template>
<script lang="ts" setup>
  import { ref } from 'vue';
  import DkTable from '/@/components/customComponent/DkTable.vue';
  import suBainForm from '/@/components/customComponent/gkpg/pgReport.vue';
  import ControlInformation from '/@/components/customComponent/gkpg/csInfor.vue';
  import unitMessageForm from '/@/components/customComponent/unitMessageForm.vue';
  import fillProgress from '/@/components/customComponent/fillProgress.vue';
  import CdUpload from '/@/components/customComponent/CdUpload.vue';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { plotDetails, updateBzdw, updateJcdw, delBzdw, delJcdw, saveXgpg } from '/@/api/common/api';
  import { useRouter } from 'vue-router';
  import { nextTick } from 'vue';

  let router = useRouter();
  const saveFlg = ref(true);
  const { createMessage } = useMessage();
  const params = ref(router.currentRoute.value.query);
  let unitMessageFormList = ref([{ id: null }]);
  let detectionMessageFormList = ref([{ id: null }]);
  // 获取地块信息
  const dsInfor = ref<any>({
    jcdw: [],
    bzdw: [],
    cbdc: {},
    xxdc: {},
    wrdkjbxxb: {},
  });

  async function getdkInfor() {
    dsInfor.value = await plotDetails({
      wrdkid: params.value.wrdkid,
      scjdbm: 'S6',
      id: params.value.id,
      pgtype: params.value.pgtype,
    });
    saveFlg.value = true;
    unitMessageFormList.value = dsInfor.value.bzdw;
    detectionMessageFormList.value = dsInfor.value.jcdw;

    if (unitMessageFormList.value.length == 0) unitMessageFormList.value.push({ id: null });
    if (detectionMessageFormList.value.length == 0) detectionMessageFormList.value.push({ id: null });
  }
  getdkInfor();

  const activeKey = ref(['1', '2', '3', '4', '5', '6', '7', '140000', '150000', '160000']);

  // 风险管控基本方案
  const chilrenReport = ref<any>(null);
  async function saveReport(event) {
    event.stopPropagation();
    const res = await chilrenReport?.value.getFormValueFxpg();
    if (res.gkfs == 1) {
      if (!res.gswz) {
        createMessage.warn('请填写网址');
        return;
      }
    }
    await saveXgpg(res);
  }
  // 效果评估管控措施
  const chilrenGkcs = ref<any>(null);
  async function addGKcs(event) {
    event.stopPropagation();
    const res = await chilrenGkcs?.value.getFormValueFxpg();
    if(res.sjxffw > dsInfor.value.wrdkjbxxb.zdmj){
        createMessage.warn('实际修复范围不能超过地块占地面积');
        return false
    }
    await saveXgpg(res);
  }

  // 编制单位开始
  const childrenBzd = ref<any>([]);
  const childRef = (el, index) => {
    if (el) childrenBzd.value[index] = el;
  };
  const callChildMethod = (index) => {
    childrenBzd.value[index].getFormValueBz();
  };
  function addUnitMessageFormList(event) {
    event.stopPropagation();
    unitMessageFormList.value.unshift({ id: null });
    nextTick(() => {
      callChildMethod(unitMessageFormList.value.length - 1);
    });
  }
  async function delMessageFormList(event, index) {
    event.stopPropagation();
    if (unitMessageFormList.value[index].id) {
      await delBzdw({ id: unitMessageFormList.value[index].id });
    }
    unitMessageFormList.value.splice(index, 1);
    childrenBzd.value.splice(index, 1);
    // getdkInfor();
  }
  async function suBainFormAddEdit(event, index) {
    event.stopPropagation();
    try {
      if (saveFlg.value) {
        saveFlg.value = false;
        const res = await childrenBzd.value[index].getFormValueBz();
        res.jgtype = 'bzdw';
        res.wthtje = String(res.wthtje);
        res.scjdbm = 'S6';
        res.pgtype = params.value.pgtype;
        // 新增的时候没有这个值
        res.wrdkid = params.value.wrdkid;
        const id = await updateBzdw(res);
        if (id != '成功') {
          unitMessageFormList.value[index] = res;
          unitMessageFormList.value[index].id = id;
        }
        saveFlg.value = true;
      } else {
        createMessage.warn('数据更新中请稍后点击');
      }
    } catch {
      saveFlg.value = true;
    }
  }
  // 编制单位结束

  const childrenjc = ref<any>([]);
  const childRefjc = (el, index) => {
    if (el) childrenjc.value[index] = el;
  };
  const callChildMethodjc = (index) => {
    childrenjc.value[index].getFormValueBz();
  };
  // 新增
  function addDetectionMessageFormList(event) {
    event.stopPropagation();
    detectionMessageFormList.value.unshift({ id: null });
    nextTick(() => {
      callChildMethodjc(detectionMessageFormList.value.length - 1);
    });
  }
  // 删除
  async function deleJcdw(event, index) {
    event.stopPropagation();
    if (detectionMessageFormList.value[index].id) await delJcdw({ id: detectionMessageFormList.value[index].id });
    detectionMessageFormList.value.splice(index, 1);
    childrenjc.value.splice(index, 1);
  }
  // 保存
  async function saveJcdw(event, index) {
    event.stopPropagation();
    try {
      if (saveFlg.value) {
        saveFlg.value = false;
        const res = await childrenjc.value[index].getFormValueBz();
        res.wthtje = String(res.wthtje);
        res.scjdbm = 'S6';
        res.pgtype = params.value.pgtype;
        res.jgtype = 'jcdw';
        res.wrdkid = params.value.wrdkid;
        const id = await updateJcdw(res);
        if (id != '成功') {
          detectionMessageFormList.value[index] = res;
          detectionMessageFormList.value[index].id = id;
        }
        saveFlg.value = true;
        // getdkInfor();
      } else {
        createMessage.warn('数据更新中请稍后点击');
      }
    } catch {
      saveFlg.value = true;
    }
  }
</script>

<style lang="less" scoped>
  :deep(.ant-collapse-borderless) {
    width: 100%;
  }
</style>
